-- Do not manually edit this file, it was auto-generated by dillonkearns/elm-graphql
-- https://github.com/dillonkearns/elm-graphql


module Github.Object.MarketplaceListing exposing (..)

import Github.InputObject
import Github.Interface
import Github.Object
import Github.Scalar
import Github.ScalarCodecs
import Github.Union
import Graphql.Internal.Builder.Argument as Argument exposing (Argument)
import Graphql.Internal.Builder.Object as Object
import Graphql.Internal.Encode as Encode exposing (Value)
import Graphql.Operation exposing (RootMutation, RootQuery, RootSubscription)
import Graphql.OptionalArgument exposing (OptionalArgument(..))
import Graphql.SelectionSet exposing (SelectionSet)
import Json.Decode as Decode


{-| URL to the listing owner's company site.
-}
companyUrl : SelectionSet (Maybe Github.ScalarCodecs.Uri) Github.Object.MarketplaceListing
companyUrl =
    Object.selectionForField "(Maybe ScalarCodecs.Uri)" "companyUrl" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecUri |> .decoder |> Decode.nullable)


{-| The HTTP path for configuring access to the listing's integration or OAuth app
-}
configurationResourcePath : SelectionSet Github.ScalarCodecs.Uri Github.Object.MarketplaceListing
configurationResourcePath =
    Object.selectionForField "ScalarCodecs.Uri" "configurationResourcePath" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecUri |> .decoder)


{-| The HTTP URL for configuring access to the listing's integration or OAuth app
-}
configurationUrl : SelectionSet Github.ScalarCodecs.Uri Github.Object.MarketplaceListing
configurationUrl =
    Object.selectionForField "ScalarCodecs.Uri" "configurationUrl" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecUri |> .decoder)


{-| URL to the listing's documentation.
-}
documentationUrl : SelectionSet (Maybe Github.ScalarCodecs.Uri) Github.Object.MarketplaceListing
documentationUrl =
    Object.selectionForField "(Maybe ScalarCodecs.Uri)" "documentationUrl" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecUri |> .decoder |> Decode.nullable)


{-| The listing's detailed description.
-}
extendedDescription : SelectionSet (Maybe String) Github.Object.MarketplaceListing
extendedDescription =
    Object.selectionForField "(Maybe String)" "extendedDescription" [] (Decode.string |> Decode.nullable)


{-| The listing's detailed description rendered to HTML.
-}
extendedDescriptionHTML : SelectionSet Github.ScalarCodecs.Html Github.Object.MarketplaceListing
extendedDescriptionHTML =
    Object.selectionForField "ScalarCodecs.Html" "extendedDescriptionHTML" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecHtml |> .decoder)


{-| The listing's introductory description.
-}
fullDescription : SelectionSet String Github.Object.MarketplaceListing
fullDescription =
    Object.selectionForField "String" "fullDescription" [] Decode.string


{-| The listing's introductory description rendered to HTML.
-}
fullDescriptionHTML : SelectionSet Github.ScalarCodecs.Html Github.Object.MarketplaceListing
fullDescriptionHTML =
    Object.selectionForField "ScalarCodecs.Html" "fullDescriptionHTML" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecHtml |> .decoder)


{-| Whether this listing has been submitted for review from GitHub for approval to be displayed in the Marketplace.
-}
hasApprovalBeenRequested : SelectionSet Bool Github.Object.MarketplaceListing
hasApprovalBeenRequested =
    Object.selectionForField "Bool" "hasApprovalBeenRequested" [] Decode.bool


{-| Does this listing have any plans with a free trial?
-}
hasPublishedFreeTrialPlans : SelectionSet Bool Github.Object.MarketplaceListing
hasPublishedFreeTrialPlans =
    Object.selectionForField "Bool" "hasPublishedFreeTrialPlans" [] Decode.bool


{-| Does this listing have a terms of service link?
-}
hasTermsOfService : SelectionSet Bool Github.Object.MarketplaceListing
hasTermsOfService =
    Object.selectionForField "Bool" "hasTermsOfService" [] Decode.bool


{-| A technical description of how this app works with GitHub.
-}
howItWorks : SelectionSet (Maybe String) Github.Object.MarketplaceListing
howItWorks =
    Object.selectionForField "(Maybe String)" "howItWorks" [] (Decode.string |> Decode.nullable)


{-| The listing's technical description rendered to HTML.
-}
howItWorksHTML : SelectionSet Github.ScalarCodecs.Html Github.Object.MarketplaceListing
howItWorksHTML =
    Object.selectionForField "ScalarCodecs.Html" "howItWorksHTML" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecHtml |> .decoder)


id : SelectionSet Github.ScalarCodecs.Id Github.Object.MarketplaceListing
id =
    Object.selectionForField "ScalarCodecs.Id" "id" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecId |> .decoder)


{-| URL to install the product to the viewer's account or organization.
-}
installationUrl : SelectionSet (Maybe Github.ScalarCodecs.Uri) Github.Object.MarketplaceListing
installationUrl =
    Object.selectionForField "(Maybe ScalarCodecs.Uri)" "installationUrl" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecUri |> .decoder |> Decode.nullable)


{-| Whether this listing's app has been installed for the current viewer
-}
installedForViewer : SelectionSet Bool Github.Object.MarketplaceListing
installedForViewer =
    Object.selectionForField "Bool" "installedForViewer" [] Decode.bool


{-| Whether this listing has been approved for display in the Marketplace.
-}
isApproved : SelectionSet Bool Github.Object.MarketplaceListing
isApproved =
    Object.selectionForField "Bool" "isApproved" [] Decode.bool


{-| Whether this listing has been removed from the Marketplace.
-}
isDelisted : SelectionSet Bool Github.Object.MarketplaceListing
isDelisted =
    Object.selectionForField "Bool" "isDelisted" [] Decode.bool


{-| Whether this listing is still an editable draft that has not been submitted for review and is not publicly visible in the Marketplace.
-}
isDraft : SelectionSet Bool Github.Object.MarketplaceListing
isDraft =
    Object.selectionForField "Bool" "isDraft" [] Decode.bool


{-| Whether the product this listing represents is available as part of a paid plan.
-}
isPaid : SelectionSet Bool Github.Object.MarketplaceListing
isPaid =
    Object.selectionForField "Bool" "isPaid" [] Decode.bool


{-| Whether this listing has been rejected by GitHub for display in the Marketplace.
-}
isRejected : SelectionSet Bool Github.Object.MarketplaceListing
isRejected =
    Object.selectionForField "Bool" "isRejected" [] Decode.bool


{-| The hex color code, without the leading '#', for the logo background.
-}
logoBackgroundColor : SelectionSet String Github.Object.MarketplaceListing
logoBackgroundColor =
    Object.selectionForField "String" "logoBackgroundColor" [] Decode.string


type alias LogoUrlOptionalArguments =
    { size : OptionalArgument Int }


{-| URL for the listing's logo image.

  - size - The size in pixels of the resulting square image.

-}
logoUrl :
    (LogoUrlOptionalArguments -> LogoUrlOptionalArguments)
    -> SelectionSet (Maybe Github.ScalarCodecs.Uri) Github.Object.MarketplaceListing
logoUrl fillInOptionals =
    let
        filledInOptionals =
            fillInOptionals { size = Absent }

        optionalArgs =
            [ Argument.optional "size" filledInOptionals.size Encode.int ]
                |> List.filterMap identity
    in
    Object.selectionForField "(Maybe ScalarCodecs.Uri)" "logoUrl" optionalArgs (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecUri |> .decoder |> Decode.nullable)


{-| The listing's full name.
-}
name : SelectionSet String Github.Object.MarketplaceListing
name =
    Object.selectionForField "String" "name" [] Decode.string


{-| The listing's very short description without a trailing period or ampersands.
-}
normalizedShortDescription : SelectionSet String Github.Object.MarketplaceListing
normalizedShortDescription =
    Object.selectionForField "String" "normalizedShortDescription" [] Decode.string


{-| URL to the listing's detailed pricing.
-}
pricingUrl : SelectionSet (Maybe Github.ScalarCodecs.Uri) Github.Object.MarketplaceListing
pricingUrl =
    Object.selectionForField "(Maybe ScalarCodecs.Uri)" "pricingUrl" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecUri |> .decoder |> Decode.nullable)


{-| The category that best describes the listing.
-}
primaryCategory :
    SelectionSet decodesTo Github.Object.MarketplaceCategory
    -> SelectionSet decodesTo Github.Object.MarketplaceListing
primaryCategory object_ =
    Object.selectionForCompositeField "primaryCategory" [] object_ identity


{-| URL to the listing's privacy policy.
-}
privacyPolicyUrl : SelectionSet Github.ScalarCodecs.Uri Github.Object.MarketplaceListing
privacyPolicyUrl =
    Object.selectionForField "ScalarCodecs.Uri" "privacyPolicyUrl" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecUri |> .decoder)


{-| The HTTP path for the Marketplace listing.
-}
resourcePath : SelectionSet Github.ScalarCodecs.Uri Github.Object.MarketplaceListing
resourcePath =
    Object.selectionForField "ScalarCodecs.Uri" "resourcePath" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecUri |> .decoder)


{-| The URLs for the listing's screenshots.
-}
screenshotUrls : SelectionSet (List (Maybe String)) Github.Object.MarketplaceListing
screenshotUrls =
    Object.selectionForField "(List (Maybe String))" "screenshotUrls" [] (Decode.string |> Decode.nullable |> Decode.list)


{-| An alternate category that describes the listing.
-}
secondaryCategory :
    SelectionSet decodesTo Github.Object.MarketplaceCategory
    -> SelectionSet (Maybe decodesTo) Github.Object.MarketplaceListing
secondaryCategory object_ =
    Object.selectionForCompositeField "secondaryCategory" [] object_ (identity >> Decode.nullable)


{-| The listing's very short description.
-}
shortDescription : SelectionSet String Github.Object.MarketplaceListing
shortDescription =
    Object.selectionForField "String" "shortDescription" [] Decode.string


{-| The short name of the listing used in its URL.
-}
slug : SelectionSet String Github.Object.MarketplaceListing
slug =
    Object.selectionForField "String" "slug" [] Decode.string


{-| URL to the listing's status page.
-}
statusUrl : SelectionSet (Maybe Github.ScalarCodecs.Uri) Github.Object.MarketplaceListing
statusUrl =
    Object.selectionForField "(Maybe ScalarCodecs.Uri)" "statusUrl" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecUri |> .decoder |> Decode.nullable)


{-| An email address for support for this listing's app.
-}
supportEmail : SelectionSet (Maybe String) Github.Object.MarketplaceListing
supportEmail =
    Object.selectionForField "(Maybe String)" "supportEmail" [] (Decode.string |> Decode.nullable)


{-| Either a URL or an email address for support for this listing's app.
-}
supportUrl : SelectionSet Github.ScalarCodecs.Uri Github.Object.MarketplaceListing
supportUrl =
    Object.selectionForField "ScalarCodecs.Uri" "supportUrl" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecUri |> .decoder)


{-| URL to the listing's terms of service.
-}
termsOfServiceUrl : SelectionSet (Maybe Github.ScalarCodecs.Uri) Github.Object.MarketplaceListing
termsOfServiceUrl =
    Object.selectionForField "(Maybe ScalarCodecs.Uri)" "termsOfServiceUrl" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecUri |> .decoder |> Decode.nullable)


{-| The HTTP URL for the Marketplace listing.
-}
url : SelectionSet Github.ScalarCodecs.Uri Github.Object.MarketplaceListing
url =
    Object.selectionForField "ScalarCodecs.Uri" "url" [] (Github.ScalarCodecs.codecs |> Github.Scalar.unwrapCodecs |> .codecUri |> .decoder)


{-| Can the current viewer add plans for this Marketplace listing.
-}
viewerCanAddPlans : SelectionSet Bool Github.Object.MarketplaceListing
viewerCanAddPlans =
    Object.selectionForField "Bool" "viewerCanAddPlans" [] Decode.bool


{-| Can the current viewer approve this Marketplace listing.
-}
viewerCanApprove : SelectionSet Bool Github.Object.MarketplaceListing
viewerCanApprove =
    Object.selectionForField "Bool" "viewerCanApprove" [] Decode.bool


{-| Can the current viewer delist this Marketplace listing.
-}
viewerCanDelist : SelectionSet Bool Github.Object.MarketplaceListing
viewerCanDelist =
    Object.selectionForField "Bool" "viewerCanDelist" [] Decode.bool


{-| Can the current viewer edit this Marketplace listing.
-}
viewerCanEdit : SelectionSet Bool Github.Object.MarketplaceListing
viewerCanEdit =
    Object.selectionForField "Bool" "viewerCanEdit" [] Decode.bool


{-| Can the current viewer edit the primary and secondary category of this
Marketplace listing.
-}
viewerCanEditCategories : SelectionSet Bool Github.Object.MarketplaceListing
viewerCanEditCategories =
    Object.selectionForField "Bool" "viewerCanEditCategories" [] Decode.bool


{-| Can the current viewer edit the plans for this Marketplace listing.
-}
viewerCanEditPlans : SelectionSet Bool Github.Object.MarketplaceListing
viewerCanEditPlans =
    Object.selectionForField "Bool" "viewerCanEditPlans" [] Decode.bool


{-| Can the current viewer return this Marketplace listing to draft state
so it becomes editable again.
-}
viewerCanRedraft : SelectionSet Bool Github.Object.MarketplaceListing
viewerCanRedraft =
    Object.selectionForField "Bool" "viewerCanRedraft" [] Decode.bool


{-| Can the current viewer reject this Marketplace listing by returning it to
an editable draft state or rejecting it entirely.
-}
viewerCanReject : SelectionSet Bool Github.Object.MarketplaceListing
viewerCanReject =
    Object.selectionForField "Bool" "viewerCanReject" [] Decode.bool


{-| Can the current viewer request this listing be reviewed for display in
the Marketplace.
-}
viewerCanRequestApproval : SelectionSet Bool Github.Object.MarketplaceListing
viewerCanRequestApproval =
    Object.selectionForField "Bool" "viewerCanRequestApproval" [] Decode.bool


{-| Indicates whether the current user has an active subscription to this Marketplace listing.
-}
viewerHasPurchased : SelectionSet Bool Github.Object.MarketplaceListing
viewerHasPurchased =
    Object.selectionForField "Bool" "viewerHasPurchased" [] Decode.bool


{-| Indicates if the current user has purchased a subscription to this Marketplace listing
for all of the organizations the user owns.
-}
viewerHasPurchasedForAllOrganizations : SelectionSet Bool Github.Object.MarketplaceListing
viewerHasPurchasedForAllOrganizations =
    Object.selectionForField "Bool" "viewerHasPurchasedForAllOrganizations" [] Decode.bool


{-| Does the current viewer role allow them to administer this Marketplace listing.
-}
viewerIsListingAdmin : SelectionSet Bool Github.Object.MarketplaceListing
viewerIsListingAdmin =
    Object.selectionForField "Bool" "viewerIsListingAdmin" [] Decode.bool
